<?php

/*
 * $Id: gulliver.php 6172 2015-08-26 13:19:11Z svnpeton $
 * charset: UTF-8
 * 
 * Remarque : pour que le système de traduction fonctionne, il ne faut pas d'espace après le l : (this->l('')).
 *
 * http://doc.prestashop.com/pages/viewpage.action?pageId=3801216#Cr%C3%A9erunmodulePrestaShop-Traductiond%27unmodule
 *
 */

if (!defined ('_PS_VERSION_'))
  exit;

class Gulliver extends Module
{
  public $tag = '';

  public function __construct ()
  {
    $this->name = 'gulliver';
    $this->tab = 'advertising_marketing';
    // Version module.
    $this->version = '2.0.10';
    $this->author = 'Mobeo';
    $this->need_instance = 0;

    parent::__construct ();

    $this->displayName = $this->l('Gulliver');
    $this->description = $this->l('Description of Gulliver module.');
    $this->confirmUninstall = $this->l('Are you sure you want to uninstall the module Gulliver?');

    $this->tag = '';
  }

  public function getVersion ()
  {
    return $this->version;
  }

  public function G_createNewAPIKey ($len = 20)
  {
    $alphabet = ".23456789abcdefghkmnpqrstuvwxyz_{}[]()";
    $api_key = '';
    for ($i = 0; $i < $len; $i++)
    {
      $api_key .= $alphabet[rand (0, strlen ($alphabet))];
    }
    return $api_key;
  }

  public function install ()
  {
    $api_key = Configuration::get ('MOD_GULLIVER_API_KEY');
    if ($api_key == '')
    {
      $api_key = $this->G_createNewAPIKey ();
    }

    $id_tab = Tab::getIdFromClassName ('AdminAdmin');
    if (empty ($id_tab))
    {
      // Compatibilité position menu pour presta 1.5
      if (version_compare (_PS_VERSION_, '1.5.0') >= 0)
        $id_tab = 18;
      else
        $id_tab = 9;
    }

    // http://www.prestacrea.com/blog/39-liste-recapitulative-des-principaux-hooks-de-prestashop
    #$ret = $this->registerHook ('productFooter');
    #$ret = $this->registerHook ('productTabContent');
    #$ret = $this->registerHook ('extraLeft');
    #$ret = $this->registerHook ('extraRight');
    #$ret = $this->registerHook ('productActions');
    
    $id_lang = (int) Configuration::get ('PS_LANG_DEFAULT');
    $TgulliverTab = array();    
    $TgulliverTab[$id_lang] = 'Gulliver'; // On force pour la langue en cours.
    // Pour toutes les langues...
    $Tlanguages = Language::getLanguages (false);
    foreach ($Tlanguages as $Tlanguage)
    {
      $id_lang = $Tlanguage['id_lang'];
      $TgulliverTab[$id_lang] = 'Gulliver';       
    }

    if (parent::install () == false
            OR !$this->registerHook ('footer')
            OR !$this->registerHook ('orderConfirmation')
            OR !$this->registerHook ('extraLeft')
            OR !Configuration::updateValue ('MOD_GULLIVER_API_KEY', $api_key)
            OR !Configuration::updateValue ('MOD_GULLIVER_CYOUSOON', '0')
            OR !Configuration::updateValue ('MOD_GULLIVER_USE_PROXY', '0')
            OR !$this->installModuleTab ('AdminGulliver', $TgulliverTab, $id_tab)
    )
    {
      return false;
    }

    return true;
  }

  public function uninstall ()
  {
    // Pour une suppression complète.
    #if (!parent::uninstall ()
    #        OR !Configuration::deleteByName ('MOD_GULLIVER_API_KEY')
    #        OR !Configuration::deleteByName ('MOD_GULLIVER_GTA_SERVER')
    #        OR !Configuration::deleteByName ('MOD_GULLIVER_GTA_PROJECT')
    #        OR !Configuration::deleteByName ('MOD_GULLIVER_CYOUSOON')
    #        OR !$this->uninstallModuleTab ('AdminGulliver'))
    #{
    #  return false;
    #}
    
    // Pour une suppression uniquement du menu (on conserve les paramètres de configuration).
    if (!parent::uninstall ()
            OR !$this->uninstallModuleTab ('AdminGulliver'))
    {
      return false;
    }
    return true;
  }

  //Affichage du tag GTA dans le bloc Produit
  public function hookextraLeft ($params)
  {
     return '';
     $has_cyousoon = Configuration::get ('MOD_GULLIVER_CYOUSOON');
     if ($has_cyousoon == '1')
       return $this->cyou($params);
     else
       return '';
  }

  #public function hookproductActions ($params)
  #{
  #   return "hookproductActions";
  #}

  #public function hookproductFooter ($params)
  #{
  #   return "hookproductFooter";
  #}

  /**
   * Uniquement si CyouSoon est activé.
   * @param type $params
   * @return type
   */
  public function cyou ($params)
  {
    $cyou_button = '';
    return $cyou_button;
  }

  // Sur la page de retour de confirmation du paiement (cheque, virement, ...)
  public function hookOrderConfirmation ($params)
  {
    // Setting parameters
    // $parameters = Configuration::getMultiple (array('PS_LANG_DEFAULT'));
    $output = '';
    $order = $params['objOrder'];
    if (Validate::isLoadedObject ($order))
    {
      $id_customer = $order->id_customer;
      $id_order = $order->id;
      // total_products, total_paid, total_paid_real
      #if (method_exists ('Tools', 'ps_round'))
      #  $prix = Tools::ps_round (floatval ($order->total_paid)); // total_shipping
      #else
      $prix = number_format ((float) $order->total_paid, 2, '.', ''); // total_shipping

      // $products = $order->getProducts();
      $nb_prod = count ($order->getProductsDetail ());
      $commercial = ''; // Nom de la regle panier appliquée... ?

      // ps_order_cart_rule ... id_order_cart_rule/id_order/id_cart_tule/name/
      // PS 1.5+ ?
      if (method_exists ($order, 'getCartRules'))
      {
        $T = $order->getCartRules ();
        if (!empty ($T[0]))
        {
          $id_cart_rule = $T[0]['id_cart_rule'];
          if (class_exists ('CartRule'))
          {
            $cart_rule = new CartRule ($id_cart_rule);
            $code = $cart_rule->code;
            if (!empty ($code))
            {
              $commercial = $code;
              // $commercial .= '-' . $T[0]['name'];
              $commercial .= ':' . $T[0]['value'];
              $commercial .= '/' . $T[0]['value_tax_excl'];
              $commercial .= '/' . $T[0]['free_shipping'];
              $commercial .= '/' . $params['currency'];
            }
          }
        }
      }

      // OK si PS1.4+
      $this->tag .=<<<EOT
  var ase_cart='T;$id_customer;$id_order;$prix;$nb_prod;$commercial';
 
EOT;
      if (version_compare (_PS_VERSION_, '1.4.0') < 0)
        $output = $this->getTag ();
    }
    return $output;
  }

  public function getTag ($url = null)
  {
    $load = '';
    $output = '';

    if ($url != null)
    {
      $output .= <<<EOT
<script type="text/javascript" src="$url"></script>

EOT;
      $load = 'ase_init_mode();';
    }

    $output .= <<<EOT
<script type="text/javascript">
$this->tag
$load
</script>
            
EOT;

    return $output;
  }

  protected function getAseUrl ($source = false)
  {
    $use_proxy = Configuration::get ('MOD_GULLIVER_USE_PROXY');
    if ($source or empty ($use_proxy))
    {
      //recupere serveur et projet gta
      $gta_server = Configuration::get ('MOD_GULLIVER_GTA_SERVER');
      $gta_project = Configuration::get ('MOD_GULLIVER_GTA_PROJECT');

      //pas d'acces GTA => on arrete
      if ($gta_server == '' || $gta_project == '')
        return false;

      //mise en forme
      $gta_https = false;
      if (strpos ($gta_server, 'http://') !== FALSE)
      {
        $gta_https = false;
        $gta_server = substr ($gta_server, 7);
      }
      if (strpos ($gta_server, 'https://') !== FALSE)
      {
        $gta_https = true;
        $gta_server = substr ($gta_server, 8);
      }
      $gta_server = str_replace ('/', '', $gta_server);
      $gta_project = str_replace ('/', '', $gta_project);

      //url du JS du GTA
      if ($gta_https)
      {
        $url_ase = 'https://' . $gta_server . '/prj/' . $gta_project . '/ase_fct.js';
      }
      else
      {
        # Site en https, lien GTA en http !
        if (!$source and isset ($_SERVER['HTTPS']))
          return '';

        $url_ase = 'http://' . $gta_server . '/prj/' . $gta_project . '/ase_fct.js';
      }
    }
    else
    {
      #if (isset ($_SERVER['HTTPS']))
      #  $url_ase = 'https://' . $_SERVER['HTTP_HOST'];
      #else
      # $url_ase = 'http://' . $_SERVER['HTTP_HOST'];
      $url_ase = '';
      $url_ase .= constant ('__PS_BASE_URI__') . 'modules/' . $this->name . '/ase.js';
    }
    return $url_ase;
  }

  /**
   * 
   * @param type $params
   * @return string
   */
  public function hookFooter ($params)
  {
    // params cart=object - cookie=object -- altern=3
    /* echo '<pre>';
      var_dump($params['cookie']);
      echo '</pre>'; */

    $url_ase = $this->getAseUrl ();
    if (empty ($url_ase))
      return;
    
    //id du produit (null si la page en cours n'est pas une page produit)
    $id_product = Tools::getValue ('id_product');
    //id de la catégorie (null si la page en cours n'est pas une page liste de produits)
    $id_category = Tools::getValue ('id_category');
    //id étape du panier (renseigné seulement si client logué)
    $order_step = Tools::getValue ('step');

    //variables génériques pour tous les cas de figure
    $current_time = time (); //time unix
    $this->tag .= "var ase_time='$current_time';" . "\n";
    if (!empty ($params["cookie"]) && isset ($params["cookie"]->email) && $params["cookie"]->email != '')//email du client
    {
      $this->tag .= "var ase_var='S01=" . addslashes ($params["cookie"]->email) . "';" . "\n";
    }

    // http://doc.prestashop.com/pages/viewpage.action?pageId=15171646#Plongerdansled%C3%A9veloppementPrestaShop-Donn%C3%A9esstock%C3%A9esdanslecookied%27unvisiteur%2Fclient
    // Remarque, cela ne met pas à l'abri d'un id non unique (mais évite d'avoir le id_connections en clair).
    if (defined ('_COOKIE_KEY_') and ! empty ($params['cookie']->id_connections))
      $this->tag .= "var ase_id = '" . addslashes (md5 (substr (_COOKIE_KEY_, 0, 10) . $params['cookie']->id_connections)) . "';" . "\n";

    // id_lang, id_currency, id_guest, id_connections, id_cart
    if (isset ($params["cookie"]->id_lang) && $params["cookie"]->id_lang != '')
      $id_lang = $params["cookie"]->id_lang;
    else
      $id_lang = null;
    if (empty ($id_lang))
      $id_lang = (int) Configuration::get ('PS_LANG_DEFAULT');
    if ($id_lang !== null)
    {
      # $Tlanguages = Language::getLanguages(false);
      # $Tlanguage =  Language::getLanguage($id_lang);
      $lang = Language::getIsoById ($id_lang);
      # $defaultLanguage = (int)(Configuration::get('PS_LANG_DEFAULT'));

      if (!empty ($lang))
        $this->tag .= "var ase_lang='$lang';" . "\n";
    }

    //////////TAGS PAGE PRODUIT//////////
    if ($id_product > 0)
    {
      //recuper la cat par défaut du produit + sa référence
      $res_requete = Db::getInstance ()->ExecuteS ('SELECT reference,id_category_default,id_manufacturer FROM ' . constant ('_DB_PREFIX_') . 'product WHERE id_product=' . (int) $id_product);

      // Catégorie
      $id_cat_product = 0;
      if (isset ($res_requete[0]['id_category_default']))
      {
        $id_cat_product = $res_requete[0]['id_category_default'];
        if (empty ($id_category))
        {
          $id_category = $id_cat_product;
        }
      }

      // Marque
      $brand = '';
      if (isset ($res_requete[0]['id_manufacturer']))
      {
        $id_manufacturer = $res_requete[0]['id_manufacturer'];
        if (!empty ($id_manufacturer))
        {
          $brand = Manufacturer::getNameById ($id_manufacturer);
          $brand = preg_replace ('/;/', '', $brand);
        }
      }

      //ref du produit
      $ref_product = '';
      if (isset ($res_requete[0]['reference']))
      {
        if ($res_requete[0]['reference'] != '')//ref existe
          $ref_product = $res_requete[0]['reference'];
        else//ref existe pas => on la crée
          $ref_product = sprintf ('G!%05d', $id_product);
      }

      $ref_product = addslashes ($ref_product);
      $brand = addslashes ($brand);

      //tags GTA
      $this->tag .=<<<EOT
var ase_ref_product='$ref_product';
var ase_info_product='$ref_product;$brand;$id_cat_product';

EOT;
    }
    //////////TAGS PAGE LISTE DE PRODUITS//////////
    // A mettre après le bloc produit (pour le calcul de $id_category)
    if ($id_category != '' && $id_category != FALSE)
    {
      $this->tag .=<<<EOT
var ase_category='$id_category';

EOT;
    }
    //////////TAGS PAGE PANIER//////////
    // if (($order_step !== false && $order_step >= 0) || version_compare (_PS_VERSION_, '1.5.0') >= 0)
    {
      if (!empty ($params['cart']) && is_object ($params['cart']) && $params['cart']->id != '' && is_int ($params['cart']->id))
      {
        $nb_prods = $params['cart']->nbProducts ();

        // 0 : Panier / Résumé.
        // 1 : Récap adresse et choix adresse / Adresse.
        // 2 : Frais de port.
        // 3 : Paiement (choix du paiement)
        // false : Page demande de confirmation du choix du paiement (si chèque).
        // http://presta-gulbox65.gulliver.com/modules/cheque/validation.php
        // Redirect vers /order-confirmation.php?id_cart, id_module, id_order, key
        {
          if ($nb_prods >= 1)
          {
            $this->tag .=<<<EOT
var ase_multi_cart=new Array();
ase_multi_cart[1]='Z;;;;;;';

EOT;

            $Tcart_content = $params['cart']->getProducts ();

            $i = 2;
            foreach ($Tcart_content as $product)
            {
              //ref du produit
              if ($product['reference'] != '')//ref existe
                $ref_product = $product['reference'];
              else//ref existe pas => on la crée
              {
                $ref_product = sprintf ('G!%05d', $product['id_product']);
                if (!empty ($product['id_product_attribute']))
                {
                  $ref_product .= sprintf ('-%05d', $product['id_product_attribute']);
                }
              }

              $product_name = str_replace (';', '', $product["name"]);

              $product_name = addslashes ($product_name);
              $ref_product = addslashes ($ref_product);

              $this->tag .=<<<EOT
ase_multi_cart[$i]='A;$product_name;$ref_product;{$product["price_wt"]};{$product["cart_quantity"]};;{$product["id_category_default"]}';

EOT;
              $i++;
            }
          }
        }
      }
    }

    ////////////////////////////////
    ///////////AFFICHAGE////////////
    ////////////////////////////////
    if ($this->tag != '')
    {
      $output = $this->getTag ($url_ase);
    }
    else
    {
      $output = '';
    }

    return $output;
  }

  public function getContent ()
  {
    if (Tools::isSubmit ('submit'))
    {
      $this->_html .= '<br clear="all" />';

      $ok = Configuration::updateValue ('MOD_GULLIVER_API_KEY', trim (Tools::getValue ('api_key')));
      $gta_server = Tools::getValue ('gta_server');
      $gta_server = preg_replace ('/[^a-zA-Z0-9\.-]+/', '', $gta_server); // sécurité (surtout en mode proxy)
      $ok2 = Configuration::updateValue ('MOD_GULLIVER_GTA_SERVER', trim ($gta_server));
      $ok3 = Configuration::updateValue ('MOD_GULLIVER_GTA_PROJECT', trim (Tools::getValue ('gta_project')));
      $ok4 = Configuration::updateValue ('MOD_GULLIVER_CYOUSOON', trim (Tools::getValue ('has_cyousoon')));
      $ok5 = Configuration::updateValue ('MOD_GULLIVER_USE_PROXY', trim (Tools::getValue ('use_proxy')));

      if ($ok && $ok2 && $ok3 && $ok4 && $ok5)
        $this->_html .= $this->l('updated'); // "Mise à jour effectuée.";
      else
        $this->_html .= $this->l('an error has occured'); // "Une erreur est survenue lors de l'enregistrement de la valeur.";

      $this->_html .= '<br clear="all" />';
      
      // Mode Proxy ... [ => ase.js en local + script PHP de redirection ]
      // Inconvénient, pas sûr d'avoir la dernière version du JS.
      // Oblige un appel CURL de serveur à serveur.
      // 
      // A n'utiliser que si il n'y a pas de certificat HTTPS de prévu OU si on veut un cookie sur le même domaine.
      //
      $use_proxy = Configuration::get ('MOD_GULLIVER_USE_PROXY');
      if ($use_proxy == '1')
      {
        $url_ase = $this->getAseUrl (true);
        if (!empty ($url_ase))
        {
          if (function_exists ('curl_init'))
          {
            $ch = curl_init ($url_ase);
            curl_setopt ($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt ($ch, CURLOPT_CONNECTTIMEOUT, 5);
            $DEFAULT_USER_AGENT = 'Gulliver/' . $this->version . ' PS/' . _PS_VERSION_;
            curl_setopt ($ch, CURLOPT_USERAGENT, $DEFAULT_USER_AGENT);
            curl_setopt ($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
            curl_setopt ($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
            $js = curl_exec ($ch);
            if (!empty ($js))
            {
              $fid = @fopen (_PS_MODULE_DIR_ . $this->name . '/ase.js', 'w');
              if ($fid)
              {
                // ase_i='http://m730171.g73.mobeo.eu/auto/ase8cf.php';
                // ase_i='/module/gulliver/ase8cf.php';
                $url_proxy = constant ('__PS_BASE_URI__') . 'modules/' . $this->name . '/ase8cf.php';
                $js = preg_replace('/http.*php/', $url_proxy, $js);
                fwrite ($fid, $js);
                fclose ($fid);
              }
            }
            $fid = @fopen (_PS_MODULE_DIR_ . $this->name . '/gulliver_config.inc.php', 'w');
            if ($fid)
            {
              $server = Configuration::get ('MOD_GULLIVER_GTA_SERVER');
              fwrite ($fid, "<?php\n\$url=\"http://$server/auto/ase8cf.php\";\n");
              fclose($fid);
            }
          }
        }
      }
    }

    $api_key = Configuration::get ('MOD_GULLIVER_API_KEY');
    $h_api_key = htmlentities ($api_key);
    
    $has_cyousoon = Configuration::get ('MOD_GULLIVER_CYOUSOON');
    $h_has_cyousoon = htmlentities ($has_cyousoon);
    
    $use_proxy = Configuration::get ('MOD_GULLIVER_USE_PROXY');
    $h_use_proxy = htmlentities ($use_proxy);
    
    $gta_server = Configuration::get ('MOD_GULLIVER_GTA_SERVER');
    $h_gta_server = htmlentities ($gta_server);

    $gta_project = Configuration::get ('MOD_GULLIVER_GTA_PROJECT');
    $h_gta_project = htmlentities ($gta_project);

    $url = htmlentities ('https://emailing.gulliver.com/');
    $txt_url = htmlentities ('emailing.gulliver.com');
    // htmlentities ( xxx, null, 'UTF-8');

    $this->_html .=
            '<br clear="all" />' .
            '<h2>' . $this->l('Gulliver Emailing for PrestaShop') . '</h2>' .
            '<fieldset><legend>' . $this->l('Informations') . '</legend>' .
            $this->l('Link to access to Gulliver Emailing:') .
            " <a href=\"$url\" target=\"_blank\">$txt_url</a>" .
            '</fieldset>';
    $this->_html .=
            '<br clear="all" />';
    $this->_html .=
            '<fieldset><legend>' . $this->l('Options') . '</legend>';

    $this->_html .=
            '<form action="' . $_SERVER['REQUEST_URI'] . '" method="post">
              
              <table>
                <tr>
                  <td> 
                    <label>' . $this->l('API key value') . '</label>
                  </td>
                  <td>
                    <input type="text" name="api_key" value="' . $h_api_key . '" size="32" />
                  </td>
                </tr>
                <tr>
                  <td>
                    <label>' . $this->l('GTA Server') . '</label>
                  </td>
                  <td>
                    <input type="text" name="gta_server" value="' . $h_gta_server . '" size="32" />
                  </td>
                </tr>
                <tr>
                  <td>
                    <label>' . $this->l('GTA Project') . '</label>
                  </td>
                  <td>
                    <input type="text" name="gta_project" value="' . $h_gta_project . '" size="32" />
                  </td>
                </tr>
                <tr>
                  <td>
                    <label>' . $this->l('CYouSoon') . '</label>
                  </td>
                  <td>
                    <input type="text" name="has_cyousoon" value="' . $h_has_cyousoon . '" size="1" /> (0|1)
                  </td>
                </tr> 
                <tr>
                  <td>
                    <label>' . $this->l('Proxy') . '</label>
                  </td>
                  <td>
                    <input type="text" name="use_proxy" value="' . $h_use_proxy . '" size="1" /> (0|1)
                  </td>
                </tr>
              </table>
              
              <input type="submit" name="submit" value="' . $this->l('Update') . '" class="button" />
              
            </form>
          </fieldset>';
    //   
    // TODO: Information sur le module Archive::Zip ?

    return $this->_html;
  }

  /**
   * 
   * @param type $tabClass
   * @param type $tabName
   * @param type $idTabParent
   * @return boolean
   */
  private function installModuleTab ($tabClass, $tabName, $idTabParent)
  {
    @copy (_PS_MODULE_DIR_ . $this->name . '/logo.gif', _PS_IMG_DIR_ . 't/' . $tabClass . '.gif');
    $tab = new Tab();
    $tab->name = $tabName;
    $tab->class_name = $tabClass;
    $tab->module = $this->name;
    $tab->id_parent = $idTabParent;

    if (!$tab->save ())
    {
      return false;
    }
    return true;
  }

  private function uninstallModuleTab ($tabClass)
  {
    $idTab = Tab::getIdFromClassName ($tabClass);
    if ($idTab != 0)
    {
      $tab = new Tab ($idTab);
      $tab->delete ();
    }

    return true;
  }
}
